# $Revision: 1.110.2.6 $, $Date: 2008/04/04 18:50:01 $
# TODO:
# Installed (but unpackaged) file(s) found:
#   /etc/hotplug/usb/xpp_fxloader
#   /etc/hotplug/usb/xpp_fxloader.usermap
#   /etc/udev/rules.d/xpp.rules
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace tools
%bcond_with	oslec		# with Open Source Line Echo Canceller
%bcond_with	bristuff	# with bristuff support
%bcond_without	xpp		# without Astribank

%ifarch sparc
%undefine	with_smp
%endif
%ifarch alpha
%undefine	with_xpp
%endif

%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif

%define		rel	5
%define		pname	zaptel
%define		FIRMWARE_URL http://downloads.digium.com/pub/telephony/firmware/releases
Summary:	Zaptel telephony device support
Summary(pl.UTF-8):	Obsługa urządzeń telefonicznych Zaptel
Name:		%{pname}%{_alt_kernel}
Version:	1.4.8
Release:	%{rel}
License:	GPL
Group:		Base/Kernel
Source0:	http://ftp.digium.com/pub/zaptel/releases/%{pname}-%{version}.tar.gz
# Source0-md5:	f57e1ba86a3dd4ef141ca3831e11c076
Source1:	%{pname}.init
Source2:	%{pname}.sysconfig
Source3:	%{FIRMWARE_URL}/zaptel-fw-oct6114-064-1.05.01.tar.gz
# Source3-md5:	18e6e6879070a8d61068e1c87b8c2b22
Source4:	%{FIRMWARE_URL}/zaptel-fw-oct6114-128-1.05.01.tar.gz
# Source4-md5:	c46a13f468b53828dc5c78f0eadbefd4
Source5:	%{FIRMWARE_URL}/zaptel-fw-vpmadt032-1.07.tar.gz
# Source5-md5:	7916c630a68fcfd38ead6caf9b55e5a1
Source6:	%{FIRMWARE_URL}/zaptel-fw-tc400m-MR6.12.tar.gz
# Source6-md5:	c57f41fae88f129e14fcaf41e4df90dc
Patch0:		%{pname}-make.patch
Patch1:		%{pname}-sangoma.patch
Patch2:		%{pname}-oslec.patch
Patch3:		%{pname}-bristuff.patch
URL:		http://www.asterisk.org/
%if %{with kernel} && %{with dist_kernel}
BuildRequires:	kernel-module-build
BuildRequires:	module-init-tools
%endif
BuildRequires:	newt-devel
BuildRequires:	perl-base
BuildRequires:	perl-tools-pod
BuildRequires:	rpmbuild(macros) >= 1.379
%{?with_bristuff:Provides:	zaptel(bristuff)}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define	modules_1	zaptel,ztd-eth,ztd-loc,pciradio,tor2,torisa,wcfxo,wct1xxp,wctdm,wcte11xp,wcusb,ztdummy,ztdynamic
%define	modules_2	wct4xxp/wct4xxp,wcte12xp/wcte12xp%{?with_xpp:,xpp/{xpd_fxo,xpd_fxs,xpd_pri,xpp,xpp_usb}}
%ifnarch alpha
%define	modules_nalpha	wctc4xxp/wctc4xxp,wctdm24xxp/wctdm24xxp,zttranscode
%endif
%if %{with bristuff}
%define	modules_bristuff cwain/cwain,qozap/qozap,vzaphfc/vzaphfc,zaphfc/zaphfc,ztgsm/ztgsm,opvxa1200,wcopenpci
%endif
%define	modules		%{modules_1},%{modules_2}%{?modules_nalpha:,%{modules_nalpha}}%{?modules_bristuff:,%{modules_bristuff}}

%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%description
Zaptel telephony device driver.

%description -l pl.UTF-8
Sterownik do urządzeń telefonicznych Zaptel.

%package devel
Summary:	Zaptel development headers
Summary(pl.UTF-8):	Pliki nagłówkowe Zaptel
Group:		Development/Libraries
Requires:	%{pname} = %{version}-%{rel}
%{?with_bristuff:Provides:	zaptel-devel(bristuff)}

%description devel
Zaptel development headers.

%description devel -l pl.UTF-8
Pliki nagłówkowe Zaptel.

%package static
Summary:	Zaptel static library
Summary(pl.UTF-8):	Biblioteka statyczna Zaptel
Group:		Development/Libraries
Requires:	%{pname}-devel = %{version}-%{rel}
%{?with_bristuff:Provides:	zaptel-static(bristuff)}

%description static
Zaptel static library.

%description static -l pl.UTF-8
Biblioteka statyczna Zaptel.

%package utils
Summary:	Zaptel utility programs
Summary(pl.UTF-8):	Programy narzędziowe Zaptel
Group:		Applications/Communications

%description utils
Zaptel card utility programs, mainly for diagnostics.

%description utils -l pl.UTF-8
Programy narzędziowe do kart Zaptel, służące głównie do diagnostyki.

%package init
Summary:	Zaptel init scripts
Summary(pl.UTF-8):	Skrypty inicjalizujące Zaptel
Group:		Applications/Communications
Requires(post,preun):	/sbin/chkconfig
Requires:	%{pname}-utils = %{version}-%{rel}
Requires:	rc-scripts

%description init
Zaptel boot-time initialization.

%description init -l pl.UTF-8
Inicjalizacja Zaptel w czasie startu systemu.

%package -n kernel%{_alt_kernel}-%{pname}
Summary:	Zaptel Linux kernel driver
Summary(pl.UTF-8):	Sterownik Zaptel dla jądra Linuksa
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
Requires(post,postun):	/sbin/depmod
%{?with_dist_kernel:Requires:	kernel%{_alt_kernel}(vermagic) = %{_kernel_ver}}
%if %{with dist_kernel}
%{?with_oslec:Requires:	kernel%{_alt_kernel}-misc-oslec(vermagic) = %{_kernel_ver}}
%endif

%description -n kernel%{_alt_kernel}-%{pname}
Zaptel telephony Linux kernel driver.

%description -n kernel%{_alt_kernel}-%{pname} -l pl.UTF-8
Sterownik dla jądra Linuksa do urządzeń telefonicznych Zaptel.

%package -n perl-Zaptel
Summary:	Perl interface to Zaptel
Summary(pl.UTF-8):	Perlowy interfejs do Zaptela
Group:		Development/Languages/Perl
Requires:	%{pname} = %{version}-%{rel}

%description -n perl-Zaptel
Perl inferface to Zaptel.

%description -n perl-Zaptel -l pl.UTF-8
Perlowy interfejs do Zaptela.

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1
%patch1 -p1
%{?with_oslec:%patch2 -p1}
%{?with_bristuff:%patch3 -p1}

%if %{with kernel}
for a in %{SOURCE3} %{SOURCE4} %{SOURCE5} %{SOURCE6}; do
	ln -s $a firmware
	tar -C firmware -xzf $a
done

cat > download-logger <<'EOF'
#!/bin/sh
# keep log of files make wanted to download in firmware/ dir
echo "$@" >> download.log
EOF
chmod a+rx download-logger
%endif

%build
%configure
%{__make} prereq zttest \
	CC="%{__cc}" \
	LDFLAGS="%{rpmldflags}" \
	OPTFLAGS="%{rpmcflags}"

%if %{with kernel}
%build_kernel_modules SUBDIRS=$PWD DOWNLOAD=$PWD/download-logger ZAP="-I$PWD" KSRC=%{_kernelsrcdir} -m %{modules}

check_modules() {
	err=0
	for a in {*/,}*.ko; do
		[[ $a = *-dist.ko ]] && continue
		echo >&2 "unpackaged module: ${a%.ko}"
		err=1
	done

	[ $err = 0 ] || exit 1
}
check_modules
%endif

%if %{with userspace}
%{__make} ztcfg torisatool makefw ztmonitor ztspeed %{?with_bristuff:ztpty} libtonezone.so \
	fxstest fxotune \
	CC="%{__cc} %{rpmcflags}" \
	LDFLAGS="%{rpmldflags}" \
	KSRC=%{_kernelsrcdir}
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
%install_kernel_modules -m %{modules} -d misc
%endif

%if %{with userspace}
install -d $RPM_BUILD_ROOT{/sbin,%{_includedir}/linux,/etc/{rc.d/init.d,sysconfig},%{_sbindir},%{_mandir}/{man1,man8}}
%{__make} -o all -o devices -j1 install \
	LIBDIR="%{_libdir}" \
	LIB_DIR="%{_libdir}" \
	INSTALL_PREFIX=$RPM_BUILD_ROOT \
	DESTDIR=$RPM_BUILD_ROOT \
	MODCONF=$RPM_BUILD_ROOT/etc/modprobe.conf \
	KSRC=%{_kernelsrcdir} \
	PERLLIBDIR=%{perl_vendorlib}
install zttest torisatool makefw ztmonitor ztspeed fxstest fxotune %{?with_bristuff:ztpty} $RPM_BUILD_ROOT%{_sbindir}
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/zaptel
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/zaptel
touch $RPM_BUILD_ROOT/etc/zaptel.conf

install zconfig.h ecdis.h fasthdlc.h biquad.h $RPM_BUILD_ROOT/usr/include/zaptel/
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n kernel%{_alt_kernel}-%{pname}
%depmod %{_kernel_ver}

%postun -n kernel%{_alt_kernel}-%{pname}
%depmod %{_kernel_ver}

%post init
/sbin/chkconfig --add %{pname}
%service %{pname} restart

%preun init
if [ "$1" = "0" ]; then
	%service %{pname} stop
	/sbin/chkconfig --del %{pname}
fi

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc README
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/zaptel.conf
%attr(755,root,root) /sbin/*
%attr(755,root,root) %{_libdir}/*.so.*
%if %{with xpp}
%{_datadir}/zaptel
%endif
%{_mandir}/man8/*

%files init
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/*
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/zaptel

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/*.so
%{_includedir}/zaptel

%files static
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/*.a

%files utils
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/*

%if %{with xpp}
%files -n perl-Zaptel
%defattr(644,root,root,755)
%{perl_vendorlib}/Zaptel
%{perl_vendorlib}/Zaptel.pm
%endif
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-%{pname}
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: zaptel.spec,v $
Revision 1.110.2.6  2008/04/04 18:50:01  glen
- /usr/share/zaptel seems xpp related which is N/A on alpha

Revision 1.110.2.5  2008-04-04 18:40:53  glen
- perl not avail on alpha either

Revision 1.110.2.4  2008-04-04 18:30:48  glen
- add bristuff modules

Revision 1.110.2.3  2008-04-04 18:24:31  glen
- filter out modules not build on alpha

Revision 1.110.2.2  2008-04-04 17:41:04  glen
- oslec module deps

Revision 1.110.2.1  2008-04-04 17:32:29  glen
- AC kernel deps

Revision 1.110  2008-04-04 17:03:17  glen
- add more modules, add modules build check

Revision 1.109  2008-04-04 16:54:47  glen
- fix only kernel build, one firmware obsolete

Revision 1.108  2008-04-04 16:46:09  glen
- better firmware download handling

Revision 1.107  2008-04-04 16:32:02  glen
- add kernel build macros back (discarded in r1.83 with 1.4.1 merge from DEVEL)

Revision 1.106  2008-04-04 16:13:46  glen
- alt kernel merge from AC-branch

Revision 1.105  2008-03-27 20:52:28  glen
- rel 4 (2.6.22.19-3)

Revision 1.104  2008-03-10 12:23:02  arekm
- release 3

Revision 1.103  2008-02-11 11:33:39  arekm
- rel 2

Revision 1.102  2008-02-09 18:42:49  arekm
- BR: perl-tools-pod for man pages

Revision 1.101  2008-02-09 17:20:11  arekm
- build some bristuff/from debian additional drivers

Revision 1.100  2008-02-09 10:16:24  arekm
- up to 1.4.8

Revision 1.99  2008-01-22 22:53:34  glen
- rel 10 (2.6.16.59-2)

Revision 1.98  2008-01-19 16:53:25  qboosh
- pl fix

Revision 1.97  2008-01-08 16:44:47  glen
- there's no kernel_ver_str in main package; rel 9

Revision 1.96  2007-12-17 14:21:24  arekm
- rel 8

Revision 1.95  2007-12-15 12:04:14  arekm
- rel 7

Revision 1.94  2007-12-11 20:43:06  adamg
- bristuff patch (and bcond)
- make use of alt_kernel macro
- introduce perl-Zaptel package
- release 6

Revision 1.93  2007-11-29 08:08:25  arekm
- rel 5

Revision 1.92  2007-11-25 10:35:14  arekm
- rel 4

Revision 1.91  2007-10-24 13:53:59  arekm
- rel 3

Revision 1.90  2007/10/12 12:52:42  arekm
- rel 2

Revision 1.89  2007/08/23 14:17:03  zbyniu
- up to 1.4.5.1; new firmwares added; set KSRC

Revision 1.88  2007/06/09 16:40:14  areq
- bcond with oslec

Revision 1.87  2007/06/09 13:48:41  areq
- 1.4.3
- add oslec.patch Open Source Line Echo Canceller
  http://www.rowetel.com/ucasterisk/oslec.html

Revision 1.86  2007/04/30 21:17:04  areq
- 1.4.2.1

Revision 1.85  2007/04/29 18:24:23  qboosh
- killed files dup

Revision 1.84  2007/04/29 18:23:55  qboosh
- tabs

Revision 1.83  2007/04/18 21:16:14  arekm
- move 1.4.1 from devel

Revision 1.70.2.12  2007/04/18 21:14:16  arekm
- up to 1.4.1

Revision 1.70.2.11  2007/04/05 23:52:47  aredridel
- remove smp
- rpmbuild(macros) >= 1.379

Revision 1.70.2.10  2007/03/04 18:38:04  aredridel
- clean build environment to force rebuild between up and smp configs

Revision 1.70.2.9  2007/03/03 16:44:40  aredridel
- 1.4.0.2273

Revision 1.70.2.8  2007/02/12 13:20:16  baggins
- converted to UTF-8

Revision 1.70.2.7  2007/01/04 21:00:26  areq
- install biquad.h

Revision 1.70.2.6  2007/01/03 22:40:54  areq
- 1.4.0

Revision 1.70.2.5  2006/11/23 12:37:05  dzeus
- fixed _rel

Revision 1.70.2.4  2006/11/23 12:31:43  dzeus
- up to beta2

Revision 1.70.2.3  2006/09/21 20:42:59  areq
- Zaptel 1.4 Beta 1

Revision 1.70.2.2  2006/09/17 21:55:18  areq
- update md5

Revision 1.70.2.1  2006/09/17 21:48:34  areq
- SVN trunk

Revision 1.70  2006/09/17 16:20:08  areq
- 1.2.9.1

Revision 1.69  2006/09/06 13:48:33  sparky
- mass atack: -j1 for make scripts

Revision 1.68  2006/08/30 09:46:45  glen
- -j1 for make scripts

Revision 1.67  2006/08/23 19:23:10  areq
- 1.2.8

Revision 1.66  2006/08/21 20:49:11  mkierus
- added SUBDIRS=$PWD to make modules

Revision 1.65  2006/08/20 00:46:56  areq
- 1.2.7

Revision 1.64  2006/08/02 02:56:59  sparky
- added as_needed-fix patch

Revision 1.63  2006/08/02 02:49:18  sparky
- sed 2 patch, LDFLAGS patch

Revision 1.62  2006/06/05 22:10:11  areq
- 1.2.6

Revision 1.61  2006/05/19 21:19:58  glen
- use %service, fix deps; rel 2

Revision 1.60  2006/04/12 12:15:40  glen
- add kernel epoch, adapterized

Revision 1.59  2006/03/27 22:22:36  areq
- 1.2.5

Revision 1.58  2006/03/17 22:03:24  glen
- rel 2

Revision 1.57  2006/03/12 16:23:12  areq
- 1.2.4

Revision 1.56  2006/03/11 12:28:27  arekm
- rel 4

Revision 1.55  2006/02/18 19:30:17  hunter
- BR:newt-devel
- include zttest util

Revision 1.54  2006/02/11 14:14:53  arekm
- rel 3

Revision 1.53  2006/02/05 12:26:39  averne
- fixed to build with 2.6.14.7
- rel 2

Revision 1.52  2006/02/04 21:37:31  averne
- updated to 1.2.3
- works fine with x86_64

Revision 1.51  2006/01/19 21:28:52  sparky
- build tools with CC="%{__cc} %{rpmcflags}" option (there is no CFLAGS)

Revision 1.50  2006/01/19 11:25:34  dzeus
- up to 1.2.2

Revision 1.49  2006/01/14 13:00:57  arekm
- rel 4; fixed sparc

Revision 1.48  2006/01/13 19:55:22  arekm
- rel 3

Revision 1.47  2006/01/12 20:54:30  arekm
- build fixes

Revision 1.46  2006/01/12 19:04:50  arekm
- rel 2

Revision 1.45  2006/01/12 18:00:16  qboosh
- no smp module on sparc(32)
- include/asm-* hack for ppc*

Revision 1.44  2005/12/17 13:01:32  averne
- updated to 1.2.1

Revision 1.43  2005/12/13 15:51:53  glen
- adapterized (sorted %verify attrs)

Revision 1.42  2005/12/07 01:15:08  glen
- better

Revision 1.41  2005/12/07 00:57:40  aredridel
- build fixes without dist_kernel

Revision 1.40  2005/12/05 20:49:00  aredridel
- up to 1.2.0

Revision 1.39  2005/09/15 18:25:05  sparky
- prepared for kernel >= 2.6.13: link Module.symvers

Revision 1.38  2005/09/14 22:13:07  areq
- 1.0.9.2

Revision 1.37  2005/05/21 21:18:59  averne
- rel 4

Revision 1.36  2005/03/25 06:16:25  havner
- rel 3

Revision 1.35  2005/03/25 06:12:44  havner
- don't remove trailing /

Revision 1.34  2005/03/25 06:10:08  havner
- sed for amd64 instead of patching

Revision 1.33  2005/03/22 21:38:42  arekm
- link with shared lib

Revision 1.32  2005/03/22 20:23:07  arekm
- add data for Poland

Revision 1.31  2005/03/22 18:17:15  arekm
- only ko are kernel modules.

Revision 1.30  2005/03/20 14:31:19  arekm
- up to 1.0.7 (Makefile patch not needed - replaced by MODCONF passing at install)

Revision 1.29  2005/03/10 20:27:18  qboosh
- config() for sysconfig file

Revision 1.28  2005/03/10 20:25:00  darekr
- fixed perms for init scripts
- %verify() for config file

Revision 1.27  2005/02/09 16:26:13  glen
- use _rel macro to prevent duplicate release expansion (kernel-smp-zaptel-1.0.0-2.1@2.6.8_4.11@2.6.8_4.11.i686.rpm) for -smp package

Revision 1.26  2005/02/09 16:08:41  glen
- don't own includedir/linux

Revision 1.25  2004/10/19 18:18:01  havner
- rel 2

Revision 1.24  2004/10/07 10:38:44  qboosh
- strict dep, simplified prep

Revision 1.23  2004/09/24 23:21:12  mguevara
- update to 1.0.0
- url/ftp change

Revision 1.22  2004/09/24 13:18:35  radek
- massive: missing %defattr (or related cosmetics)

Revision 1.21  2004/09/08 20:27:30  qboosh
- pl for -init

Revision 1.20  2004/09/08 04:32:49  aredridel
- added init scripts

Revision 1.19  2004/08/30 19:38:16  aredridel
- up to 20040830

Revision 1.18  2004/08/28 22:55:10  aredridel
- don't replace config files

Revision 1.17  2004/08/19 00:37:47  havner
- wrr, forgot about ifarch

Revision 1.16  2004/08/19 00:25:59  havner
- amd64 fix

Revision 1.15  2004/08/19 00:20:28  havner
- rel 4

Revision 1.14  2004/08/18 01:02:48  havner
- rel 3

Revision 1.13  2004/07/29 16:14:29  qboosh
- updated rpmbuild BR

Revision 1.12  2004/07/29 16:10:59  qboosh
- new bconds, thinko

Revision 1.11  2004/07/28 18:45:12  havner
- rel 2 for rebuild with new kernel

Revision 1.10  2004/06/18 11:00:19  kali
- missing Requires in -devel

Revision 1.9  2004/05/30 00:28:34  arekm
- move zap devices to dev.spec

Revision 1.8  2004/05/30 00:20:22  arekm
- updated to 0.9.1

Revision 1.7  2004/05/26 01:04:54  aredridel
- updated build scripts

Revision 1.6  2004/04/13 19:55:26  qboosh
- fixed -utils attr, no need to bcond preamble

Revision 1.5  2004/04/12 22:53:02  aredridel
- actually install utilities
- added -utils subpackage

Revision 1.4  2004/04/10 09:45:42  qboosh
- cleanups, pl, kernel/userspace bconds

Revision 1.3  2004/04/09 21:31:01  aredridel
- no kernel version on main package

Revision 1.2  2004/04/09 21:07:45  aredridel
- oops -- make mrproper was eating the smp modules

Revision 1.1  2004/04/09 19:25:55  aredridel
- added
